import os, urllib
from DateTime import DateTime
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction, afterCreate

# Import permission names
from Products.CMFCore import CMFCorePermissions
import EmploymentPermissions

factory_type_information = (
    {'id': 'Job Posting',
     'content_icon': 'ico_job_posting.gif',
     'meta_type': 'CMF Job Posting',
     'description': ('Job Postings are employment opportunities for use in Employment topical '
                     'queries on the catalog.'),
     'product': 'CMFEmployment',
     'factory': 'addJobPosting',
     'immediate_view': 'job_edit_form',
     'actions': ({'id': 'view',
                  'name': 'View',
                  'action': 'job_view',
                  'permissions': (CMFCorePermissions.View,)},
                 {'id': 'edit',
                  'name': 'Edit',
                  'action': 'job_edit_form',
                  'permissions': (EmploymentPermissions.modifyContent,) },
                 {'id': 'metadata',
                  'name': 'Metadata',
                  'action': 'metadata_edit_form',
                  'permissions': (EmploymentPermissions.modifyContent,) }
                 )                     # End Actions
    },
)

def addJobPosting(self
             , id
             , title=''
             , description=''
             , subject=''
             , effective_date = DateTime() 
             , expiration_date = DateTime() 
             , location=''
             , contact_name=''
             , contact_email=''
             , contact_phone=''
             , job_url=''
             , city=''
             , career_level=''
             , position_type=''
             , salary_min=''
             , salary_max=''
             , salary_period=''
             , poster_hidden=''
             , display_contact_name=''
             , display_contact_email=''
             , poster_comp_name=''  # contact/job poster info below
             , display_poster_comp_name=''
             , poster_comp_address=''
             , display_poster_comp_address=''
             , poster_city=''
             , display_poster_city=''
             , poster_state=''
             , display_poster_state=''
             , poster_zipcode=''
             , display_poster_zipcode=''
             , poster_phone1=''
             , display_poster_phone1=''
             , poster_phone2=''
             , display_poster_phone2=''
             , effectiveDay=DateTime().strftime('%d')
             , effectiveMo=DateTime().strftime('%m')
             , effectiveYear=DateTime().strftime('%Y')
             , expirationDay=DateTime().strftime('%d')
             , expirationMo=DateTime().strftime('%m')
             , expirationYear=DateTime().strftime('%Y')
             , start_time=''
             , startAMPM='AM'
             , stopAMPM='AM'
             , stop_time=''
             , REQUEST=None):
    """
    Create an empty job opening.
    """
    job = JobPosting(id
             , title
             , description
             , subject
             , effective_date
             , expiration_date
             , location
             , contact_name
             , contact_email
             , contact_phone
             , job_url
             , city
             , career_level
             , position_type
             , salary_min
             , salary_max
             , salary_period
             , poster_hidden
             , display_contact_name
             , display_contact_email
             , poster_comp_name  # contact/job poster info below
             , display_poster_comp_name
             , poster_comp_address
             , display_poster_comp_address
             , poster_city
             , display_poster_city
             , poster_state
             , display_poster_state
             , poster_zipcode
             , display_poster_zipcode
             , poster_phone1
             , display_poster_phone1
             , poster_phone2
             , display_poster_phone2
             , effectiveDay
             , effectiveMo
             , effectiveYear
             , expirationDay
             , expirationMo
             , expirationYear
             , start_time
             , startAMPM
             , stopAMPM
             , stop_time
             )
    self._setObject(id, job)
    afterCreate(self.this()._getOb(id))

def _dateStrings( when ):
    strings = {}
    if when is not None:
        strings[ 'year' ]   = str( when.year() )
        strings[ 'month' ]  = str( when.month() )
        strings[ 'day' ]    = str( when.day() )
    else:
        strings[ 'year' ]   = ''
        strings[ 'month' ]  = ''
        strings[ 'day' ]    = ''

    return strings

class JobPosting(PortalContent, DefaultDublinCoreImpl):
    """
    Events are objects for the Calendar topical query.
    """
    meta_type='CMF Job Posting'

    # Declarative security
    security = ClassSecurityInfo()
    security.declareObjectProtected(CMFCorePermissions.View)
   
    #def getEditView(self):
    #    return getattr(self, 'job_edit_form')(None, self.REQUEST)
 
    def __init__(self
                 , id
                 , title=''
                 , description=''
                 , subject=''
                 , effective_date = DateTime() 
                 , expiration_date = DateTime() 
                 , location=''
                 , contact_name=''
                 , contact_email=''
                 , contact_phone=''
                 , job_url=''
                 , city=''
     	         , career_level=''
           	 , position_type=''
                 , salary_min=''
                 , salary_max=''
                 , salary_period=''
                 , poster_hidden=''
                 , display_contact_name=''
                 , display_contact_email=''
                 , poster_comp_name=''  # contact/job poster info below
                 , display_poster_comp_name=''
                 , poster_comp_address=''
                 , display_poster_comp_address=''
                 , poster_city=''
                 , display_poster_city=''
                 , poster_state=''
                 , display_poster_state=''
                 , poster_zipcode=''
                 , display_poster_zipcode=''
                 , poster_phone1=''
                 , display_poster_phone1=''
                 , poster_phone2=''
                 , display_poster_phone2=''
                 , effectiveDay=''
                 , effectiveMo=''
                 , effectiveYear=''
                 , expirationDay=''
                 , expirationMo=''
                 , expirationYear=''
                 , start_time=''
                 , startAMPM=''
                 , stopAMPM=''
                 , stop_time=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.setTitle(title)
        self.setDescription(description)
        self.setSubject(subject)
        self.setEffectiveDate(effective_date)
        self.setExpirationDate(expiration_date)
        self.location=location
        self.contact_name=contact_name
        self.contact_email=contact_email
        self.contact_phone=contact_phone
        self.job_url=job_url
        self.city=city
        self.career_level=career_level
        self.position_type=position_type
        self.salary_min=salary_min
        self.salary_max=salary_max
        self.salary_period=salary_period
        self.poster_hidden=poster_hidden
        self.display_contact_email=display_contact_email
        self.display_contact_name=display_contact_name
        self.display_poster_comp_name=display_poster_comp_name
        self.display_poster_comp_address=display_poster_comp_address
        self.display_poster_city=display_poster_city
        self.display_poster_state=display_poster_state
        self.display_poster_zipcode=display_poster_zipcode
        self.display_poster_phone1=display_poster_phone1
        self.display_poster_phone2=display_poster_phone2
        self.poster_comp_name=poster_comp_name
        self.poster_comp_address=poster_comp_address
        self.poster_city=poster_city
        self.poster_state=poster_state
        self.poster_zipcode=poster_zipcode
        self.poster_phone1=poster_phone1
        self.poster_phone2=poster_phone2
        self.effectiveDay=effectiveDay
        self.effectiveMo=effectiveMo
        self.effectiveYear=effectiveYear
        self.expirationDay=expirationDay
        self.expirationMo=expirationMo
        self.expirationYear=expirationYear
        self.start_time=start_time
        self.startAMPM=startAMPM
        self.stopAMPM=stopAMPM
        self.stop_time=stop_time
        
    
    security.declarePublic('getExpirationStrings')
    def getExpirationStrings(self):
        """
        """
        return _dateStrings(self.getExpirationDate())

    security.declarePublic('getEffectiveStrings')
    def getEffectiveStrings(self):
        """
        """
        return _dateStrings(self.effective_date)

    security.declareProtected(EmploymentPermissions.modifyContent, 'edit') 
    def edit(self
             , title=None
             , description=None
             , subject=None
             , location=None
             , contact_name=None
             , contact_email=None
             , contact_phone=None
             , job_url=None
             , city=None
             , career_level=None
             , position_type=None
             , salary_min=None
             , salary_max=None
             , salary_period=None
             , poster_hidden=None
             , display_contact_name=None
             , display_contact_email=None
             , poster_comp_name=None  # contact/job poster info below
             , display_poster_comp_name=None
             , poster_comp_address=None
             , display_poster_comp_address=None
             , poster_city=None
             , display_poster_city=None
             , poster_state=None
             , display_poster_state=None
             , poster_zipcode=None
             , display_poster_zipcode=None
             , poster_phone1=None
             , display_poster_phone1=None
             , poster_phone2=None
             , display_poster_phone2=None
             , effectiveDay=DateTime().strftime('%d')
             , effectiveMo=DateTime().strftime('%m')
             , effectiveYear=DateTime().strftime('%Y')
             , expirationDay=DateTime().strftime('%d')
             , expirationMo=DateTime().strftime('%m')
             , expirationYear=DateTime().strftime('%Y')
             , start_time='12:00'
             , startAMPM='AM'
             , stopAMPM='AM'
             , stop_time='12:00'
             , REQUEST=None
            ):
        """\
        """
        if title is not None: 
            self.setTitle(title)
        if description is not None:
            self.setDescription(description)
        if subject is not None:
            self.setSubject(subject)

        exdate = '%s/%s/%s 12:00 AM' % (expirationDay
                                 , expirationMo
                                 , expirationYear
                                 ) 
        print 'exdate', exdate
        self.setEffectiveDate(DateTime())
        self.setExpirationDate(exdate)
        self.end_date=DateTime(exdate)
        if location is not None:
            self.location = location
        if contact_name is not None:
            self.contact_name = contact_name
        if contact_email is not None:
            self.contact_email = contact_email
        if contact_phone is not None:
            self.contact_phone = contact_phone
        if job_url is not None:
            self.job_url = job_url
        if city is not None:
            self.city = city
        if career_level is not None:
            self.career_level=career_level
        if position_type is not None:
            self.position_type=position_type
        if salary_min is not None:
            self.salary_min=salary_min
        if salary_max is not None:
            self.salary_max=salary_max
        if salary_period is not None:
           self.salary_period=salary_period
        #optionally displayed information
        self.poster_hidden=poster_hidden #can be None
        self.display_contact_name=display_contact_name
        self.display_contact_email=display_contact_email

        self.poster_comp_name=poster_comp_name
        self.display_poster_comp_name=display_poster_comp_name
        self.poster_comp_address=poster_comp_address
        self.display_poster_comp_address=display_poster_comp_address
        self.poster_city=poster_city
        self.display_poster_city=display_poster_city
        self.poster_state=poster_state
        self.display_poster_state=display_poster_state
        self.poster_zipcode=poster_zipcode
        self.display_poster_zipcode = display_poster_zipcode
        self.poster_phone1=poster_phone1
        self.display_poster_phone1 = display_poster_phone1
        self.poster_phone2=poster_phone2
        self.display_poster_phone2 = display_poster_phone2

        self.reindexObject()

    edit = WorkflowAction(edit) 
    
    security.declarePublic('buildDays')
    def buildDays(self):
        result = []
        for day in range (1, 32):
            result.append(str('%d' % (day)))
        return result

    security.declarePublic('buildMonths')
    def buildMonths(self):
        result = []
        for month in range (1, 13):
            result.append(str('%d' % (month)))
        return result
    
    security.declarePublic('buildYears')
    def buildYears(self):
        result = []
        start = (DateTime().year() - 2)
        end = (DateTime().year() + 5)
        for year in range (start, end):
            result.append(str(year))
        return result

    security.declarePublic('start')
    def start(self):
        """
            Return our start time as a string.
        """
        date = getattr( self, 'start_date', None )
        return date is None and self.created() or date

    security.declarePublic('end')
    def end(self):
        """
            Return our stop time as a string.
        """
        date = getattr( self, 'end_date', None )
        return date is None and self.start() or date

    security.declarePrivate( '_datify' )
    def _datify( self, attrib ):
        if attrib == 'None':
            attrib = None
        elif not isinstance( attrib, DateTime ):
            if attrib is not None:
                attrib = DateTime( attrib )
        return attrib

    security.declarePublic('getEndStrings')
    def getEndStrings(self):
        """
        """
        print self.end()
        return _dateStrings(self.end())

    security.declarePublic('getStartTimeString')
    def getStartTimeString( self ):
        """
            Return our start time as a string.
        """
        return self.effective().AMPMMinutes() 

    security.declarePublic('getStopTimeString')
    def getStopTimeString( self ):
        """
            Return our stop time as a string.
        """
        return self.expires().AMPMMinutes() 

# Intialize the Event class, setting up security.
InitializeClass(JobPosting)
