from Products.CMFDefault import Portal
import Products.CMFCore

from Products.CMFCore import utils, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory

from Products.CMFEmployment import Resume, JobPosting

import sys
this_module = sys.modules[ __name__ ]

contentConstructors = (Resume.addResume, JobPosting.addJobPosting)
contentClasses = (Resume.Resume, JobPosting.JobPosting)

z_bases = utils.initializeBasesPhase1( contentClasses, this_module )

# This is used by a script (external method) that can be run
# to set up Events in an existing CMF Site instance.
resume_globals=globals()
jobposting_globals=globals()

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/employment', globals())

def initialize( context ):
    utils.initializeBasesPhase2( z_bases, context )
    context.registerHelpTitle('CMF Resume Help')
    context.registerHelp(directory='help')
    utils.ContentInit( 'CMF Resume'
                     , content_types = contentClasses
                     , permission = CMFCorePermissions.AddPortalContent 
                     , extra_constructors = contentConstructors
                     , fti = Resume.factory_type_information
                     ).initialize( context ) 

def initialize( context ):
    utils.initializeBasesPhase2( z_bases, context )
    context.registerHelpTitle('CMF Job Posting Help')
    context.registerHelp(directory='help')
    utils.ContentInit( 'CMF Job Posting'
                     , content_types = contentClasses
                     , permission = CMFCorePermissions.AddPortalContent
                     , extra_constructors = contentConstructors
                     , fti = JobPosting.factory_type_information
                     ).initialize( context ) 


